import greenfoot.*;

/**
 * Een levende vleermuis
 */
public class LevendeVleermuis extends Vleermuis {

    private void stijg() {
        setLocation (getX(), getY() - 15);
        setImage ("vleermuis2.png");
        snelheid = 0;        
    }

    /**
     * Kijk of de grond, het plafond of een stekel worden geraakt
     */
    private boolean isGeraakt() {
        int halveHoogte = getImage().getHeight()/2;
        return
        // plafond
        getY() < 24 + halveHoogte ||
            // grond
        getY() > 400 -24 - halveHoogte ||
            // stekels
        isTouching(Stekel.class);
    }    

    /**
     * Sterf nadat een stekel is geraakt
     */
    private void sterf() {
        World world = getWorld();
        int y = getY();

        // verwijder mezelf van de wereld
        world.removeObject(this);
        // zet een dode vleermuis in de plaats
        world.addObject(new DodeVleermuis(), 260, y);
    }

    /**
     * Beweeg op en neer. Controleer of de vleermuis is geraakt. 
     */
    public void act() 
    {
        if (isGeraakt()) {
            sterf();
        } else if ("space".equals(Greenfoot.getKey())) {
            stijg();
        } else {
            val();
        }

    }    
}
